//This file of Petrol Station Simulation defines
//all The classes & miscellaneous functions used in the main file
#include"fstream.h"
#include"graphics.h"
#include"conio.h"
#include"stdlib.h"
#include"dos.h"
#include"mouseh.cpp"
#include"pb_bitmp.cpp"
#include"pb_gui.cpp"
#define curr_time (long unsigned int far *)0x46c
#define TANK1_POS 120
#define TANK2_POS 330
#define FIRST_POS 550
#define SECOND_POS 440
#define THIRD_POS 330
#define FOURTH_POS 220
#define FIFTH_POS 110
#define TRUE 1
#define FALSE 0
int current_time();
void Print_Station_status();
enum hour_type {peak_hour,offpeak_hour,moderate_hour};
enum veh_type{bike,car,jeep};
class vehicle;
vehicle* create_random_vehicle(int);
vbitmaps vb;
fstream repfile;
int fill_time,fill_time2;
int total_veh=0;
int fill_veh_present=FALSE,fill_veh_present2=FALSE;
unsigned long int refresh_time;

class record//Storage class for storing one vehicle record
{
	public:
	int vehtype;
	int fuel_consumed;
	int waiting_time;
}rec;

class Options
{
	public:
		int no_of_pumps;
		hour_type hour;
		static int tank_capacity;
		void welcome();
		int Get_options();
		Options()
		{
			no_of_pumps=1;
			tank_capacity=100;
			hour=peak_hour;
		}
};

int Options::tank_capacity;

void Options::welcome()
{
	cmdbutton exit_button,next_button;
	windows welcome_window;
	HideMouse();
	welcome_window.show(10,10,790,590,"Welcome");
	drawbmp("pb_welcm.bmp",35,55);
	next_button.show(160,550,260,570,"Next");
	exit_button.show(500,550,600,570,"Exit");
	ShowMouse();
	while(!next_button.mouseclick())
	if(exit_button.mouseclick())
	{
		closegraph();
		exit(0);
	}
}

int Options::Get_options()
{
	HideMouse();
	windows optionswindow;
	optionswindow.show(100,75,540,405,"Options");//draw window
	cmdbutton startbutton,exitbutton,closebutton,helpbutton;
	cmdbutton left,right;
	char t_cap[4];//to store string values of tank capacity
	closebutton.show(525,77,539,89,"x");
	startbutton.show(170,370,250,390,"Start");
	helpbutton.show(275,370,355,390,"Help");
	exitbutton.show(380,370,460,390,"Exit");
	left.show(360,168,375,180,"");
	right.show(405,168,420,180,"");
	setfillstyle(SOLID_FILL,WHITE);
	bar(377,180,403,168);
	outtextxy(378,170,"100");
	outtextxy(375,145,"Tank");
	outtextxy(360,155,"Capacity");
	setcolor(WHITE);
	rectangle(181,121,451,201);//white border for frame1
	rectangle(181,251,451,350);//white border for frame2
	setcolor(DARKGRAY);
	rectangle(180,120,450,200);//frame 1
	rectangle(180,250,450,349);//frame 2
	setcolor(BLACK);
	settextstyle(2,0,4);
	setcolor(LIGHTGRAY);
	outtextxy(189,114,""); //erase frame area to print label
	setcolor(BLACK);
	outtextxy(191,114,"Pumps");   //print label
	setcolor(LIGHTGRAY);
	outtextxy(189,245,""); //erase frame area to print label
	setcolor(BLACK);
	outtextxy(191,245,"Hours");   //print label
	optionbutton  pump_op[2];
	optionbutton  hour_op[3];
	pump_op[0].showbutton(250,145);//show the Single pump option button
	pump_op[1].showbutton(250,175);//show the Double pump option button
	outtextxy(265,139,"Single Pump");
	outtextxy(265,169,"Double Pump");
	hour_op[0].showbutton(250,270); //show the Peak hour option button
	hour_op[1].showbutton(250,300); //show the Non-peak hour option button
	hour_op[2].showbutton(250,330); //show the Moderate hour option button
	outtextxy(265,264,"Peak Hour");
	outtextxy(265,294,"Off-Peak Hour");
	outtextxy(265,324,"Moderate Hour");
	pump_op[0].select();
	hour_op[0].select();
	ShowMouse();

	while(!closebutton.mouseclick())
	{

		if(pump_op[0].mouseclick())//mouse click on the Single pump option
		{
			pump_op[0].select();
			pump_op[1].unselect();
			no_of_pumps=1;
		}

		if(pump_op[1].mouseclick())//mouse click on the Double pump option
		{
			pump_op[1].select();
			pump_op[0].unselect();
			no_of_pumps=2;
		}

		if(hour_op[0].mouseclick()) //mouse click on peak hour option
		{
			hour_op[0].select();
			hour_op[1].unselect();
			hour_op[2].unselect();
			hour=peak_hour;
		}

		if(hour_op[1].mouseclick()) //mouse click on offpeak hour option
		{
			hour_op[0].unselect();
			hour_op[1].select();
			hour_op[2].unselect();
			hour=offpeak_hour;
		}

		if(hour_op[2].mouseclick())//mouse click on modereate hour option
		{
			hour_op[0].unselect();
			hour_op[1].unselect();
			hour_op[2].select();
			hour=moderate_hour;
		}

		if(left.mouseclick())
		{
			if(tank_capacity>100)
			tank_capacity-=50;
			setfillstyle(SOLID_FILL,WHITE);
			bar(377,180,403,168);
			itoa(tank_capacity,t_cap,10);
			outtextxy(378,170,t_cap);
		}

		if(right.mouseclick())
		{
			if(tank_capacity<800)
			tank_capacity+=50;
			setfillstyle(SOLID_FILL,WHITE);
			bar(377,180,403,168);
			itoa(tank_capacity,t_cap,10);
			outtextxy(378,170,t_cap);
		}

		if(startbutton.mouseclick())
			return 1;

		if(helpbutton.mouseclick())
			return 2;

		if(exitbutton.mouseclick())
		{
			closegraph();
			exit(0);
		}
	}
	cleardevice();
	return 0;
}

class vehicle 			//Base class
{

	protected:
		void *veh_bitmap;
	public:
		unsigned long int wait_start,wait_stop;
		int wait_flag;
		veh_type cveh;
		float fuel_consumed;
		int xpos,ypos;
		void shownext(int);
		void Print_Serve_status();
		void Print_Serve_status2();
		void Start_consuming(int);
		vehicle()
		{
			wait_flag=FALSE;
		}

};

class twowheeler : public vehicle         //Derived class for bike
{
	public:
	twowheeler(int yp)
	{
		veh_bitmap=vb.bike[rand()%2];
		fuel_consumed=(rand()%5)+2;
		ypos=yp;
		xpos=0;
		cveh=bike;

	}
};


class fourwheeler1:public vehicle //car
{
	public:
	fourwheeler1(int yp)
	{
		veh_bitmap=vb.car[rand()%3];
		fuel_consumed=(rand()%17)+3;
		ypos=yp;
		xpos=0;
		cveh=car;
	}
};


class fourwheeler2 :public vehicle //Jeep
{
	public:
	fourwheeler2(int yp)
	{
		veh_bitmap=vb.jeep[rand()%3];
		fuel_consumed=(rand()%20)+5;
		ypos=yp;
		xpos=0;
		cveh=jeep;
	}
};

vehicle* create_random_vehicle(int row)
{
	int rno;
	rno=rand()%3;
	if(rno==0)
		return new twowheeler(row);
	else
	if(rno==1)
		return new fourwheeler1(row);
	else
		return new fourwheeler2(row);
}

void vehicle::shownext(int pos)//to move the vehicles to their respective positions in Queue
{
	int prev_pos=xpos;
	switch(pos)
	{
	case 4:
		if(xpos<FIFTH_POS)
			xpos++;
		break;
	case 3:
		if(xpos<FOURTH_POS)
			xpos++;
		break;
	case 2:
		if(xpos<THIRD_POS)
			xpos++;
		break;
	case 1:
		if(xpos<SECOND_POS)
			xpos++;
		break;
	case 0:
		if(xpos<FIRST_POS)
			xpos++;
		break;
	case -1:
		if(xpos<690)
			xpos+=2;
		break;
	}

	if(prev_pos==xpos)//If the vehicle has not moved in the queue, start the waiting time
	{
		if(wait_flag==FALSE&&pos>0)
		{
			wait_start=current_time();
			wait_flag=TRUE;
		}
	}
	else//else show the vehicle in its next position
		putimage(xpos,ypos,veh_bitmap,COPY_PUT);
}

void vehicle::Start_consuming(int tank_no)
{
	if (fuel_consumed>Options::tank_capacity) // if fuel_remaining < required fuel then required fuel=remaining fuel of tank
	fuel_consumed=Options::tank_capacity;
	Options::tank_capacity-=fuel_consumed;//reduce the tank capacity of the amount of fuel consumed
	if(tank_no==1)//If the Tank 1 vehicle is Consuming fuel
	{
		fill_veh_present=TRUE;
		fill_time=current_time()+fuel_consumed;
	}
	else //if Tank2 vehicle is consuming fuel
	{
		fill_veh_present2=TRUE;
		fill_time2=current_time()+fuel_consumed;
	}
	xpos++;
	wait_stop=current_time();//stop the waiting time
	total_veh++;
}

void vehicle::Print_Serve_status()
{
	char fuel[5],*veh[]={"Bike","Car","Jeep"};
	setcolor(1);
	setfillstyle(SOLID_FILL,138);//for erasing the previous values
	bar(175,515,210,530);//erase previous value of vehicle type
	outtextxy(175,520,veh[cveh]);//print the current vehicle type
	itoa(fuel_consumed,fuel,10);
	bar(175,547,190,560);    //erase previous fuel value
	outtextxy(175,550,fuel); //print new fuel value
	outtextxy(193,550,"Lts");
	setfillstyle(SOLID_FILL,1);//erase previous progress bar
	bar(30,575,230,580);
	setfillstyle(SOLID_FILL,0);
	bar(30,575,(30+(fill_time-current_time())*8),580);//display current progress
}


void vehicle::Print_Serve_status2()
{
	char fuel[5],*veh[]={"Bike","Car","Jeep"};
	setcolor(1);
	setfillstyle(SOLID_FILL,138);//for erasing the previous values
	bar(700,515,735,530);//erase previous value of vehicle type
	outtextxy(700,520,veh[cveh]);//print the current vehicle type
	itoa(fuel_consumed,fuel,10);
	bar(700,547,720,560);    //erase previous fuel value
	outtextxy(700,550,fuel); //print new fuel value
	outtextxy(713,550," Lts");
	setfillstyle(SOLID_FILL,1);//erase previous progress bar
	bar(555,575,755,580);
	setfillstyle(SOLID_FILL,0);
	bar(555,575,(555+(fill_time2-current_time())*8),580);//display current progress
}


class pump
{
	public:
		void showpump(int);
};

void pump::showpump(int pumps)
{
	setcolor(222);
	outtextxy(585,100,"Pump 1");
	line(0,95,799,95);
	line(0,190,799,190);
	putimage(550,50,vb.pump,COPY_PUT);//Display one pump
	outtextxy(60,500,"Pump 1 Status");
	outtextxy(40,520,"Current vehicle:");//for pump1 status
	outtextxy(40,550,"Fuel Consumption:");//for pump1 status
	if(pumps==2)
	{
		outtextxy(585,310,"Pump 2");
		line(0,305,799,305);
		line(0,400,799,400);
		putimage(550,260,vb.pump,COPY_PUT);//Display 2 pumps
		outtextxy(585,500,"Pump 2 Status");
		outtextxy(565,520,"Current vehicle:");//for pump2 status
		outtextxy(565,550,"Fuel Consumption:");//for pump2 status
	}
}

class Report_generator
{
private:
	void Display_summary();
	void Display_reportpage(int,int);
	void Display_graph();
	void Display_details();
public:
	void Add_record(vehicle*);
	int Display_menu();
};

int Report_generator::Display_menu()
{
	windows menu_window;
	cmdbutton closebutton,summary_button,graph_button,details_button;
	HideMouse();
	menu_window.show(200,100,550,450,"Simulation Reports");
	closebutton.show(533,102,549,115,"x");
	summary_button.show(270,180,470,220,"Summary");
	details_button.show(270,260,470,300,"Vehicle Details");
	graph_button.show(270,340,470,380,"Graph");
	ShowMouse();
	while(!closebutton.mouseclick())
	{
		if(summary_button.mouseclick())
		{
			Display_summary();
			return 0;
		}
		if(details_button.mouseclick())
		{
			Display_details();
			return 0;
		}
		if(graph_button.mouseclick())
		{
			Display_graph();
			return 0;
		}
	}
return 1;
}

void Report_generator::Add_record(vehicle *v)
{
	rec.fuel_consumed=v->fuel_consumed;
	rec.vehtype=v->cveh;
	if(v->wait_flag)
	rec.waiting_time=v->wait_stop-v->wait_start;
	else
	rec.waiting_time=0;
	repfile.write((char*)&rec,sizeof(rec));//write current vehicle data into report file
}

void Report_generator::Display_summary()
{
	char msg[6][34];
	int total_cars=0,total_jeeps=0,total_bikes=0;
	float total_wait_time=0,avg_wait_time;
	int total_fuel_consumed=0;
	windows summarywindow;
	cmdbutton closebutton;
	HideMouse();
	repfile.open("report.dat",ios::in|ios::binary);
	summarywindow.show(230,120,550,420,"Summary of Events");
	closebutton.show(535,122,548,133,"x");
	setcolor(DARKGRAY);
	rectangle(250,155,530,400);//dark border for frame
	setcolor(WHITE);
	rectangle(251,156,531,401);//white border for frame
	setcolor(BLACK);
	repfile.seekg(0,ios::beg);//seek the starting point of the report
	for(int curr_veh=0;curr_veh<total_veh;curr_veh++)//read the file and calculate the summary
	{
		repfile.read( (char*)&rec,sizeof(rec));
		if(rec.vehtype==bike)
			total_bikes++;
		if(rec.vehtype==car)
			total_cars++;
		if(rec.vehtype==jeep)
			total_jeeps++;
		total_fuel_consumed+=rec.fuel_consumed;
		total_wait_time+=rec.waiting_time;
	}
	avg_wait_time=total_wait_time/total_veh;
	settextstyle(DEFAULT_FONT,0,1);
	sprintf(msg[0],"Total Vehicles: %d",total_veh);
	sprintf(msg[1],"Total fuel consumed: %d litre(s)",total_fuel_consumed);
	sprintf(msg[2],"Average Waiting time: %.2f",avg_wait_time);
	sprintf(msg[3],"Total Cars: %d",total_cars);
	sprintf(msg[4],"Total Jeeps: %d",total_jeeps);
	sprintf(msg[5],"Total Bikes: %d",total_bikes);
	for (int i=0;i<6;i++)
		outtextxy(260,190+i*30,msg[i]);
	ShowMouse();
	while(!closebutton.mouseclick());
		repfile.close();
}

void Report_generator::Display_reportpage(int pageno,int items)
{
	int cur=(sizeof(record)*25)*pageno;
	repfile.open("report.dat",ios::in|ios::binary);
	repfile.seekg(cur,ios::beg);//seek the starting point of the page
	char slno[4],veh[5],fuel[15],wait[15],pno[2];
	int row,curr_veh;
	int endloc=pageno*25+items;
	setcolor(104);
	setfillstyle(SOLID_FILL,LIGHTGRAY);
	for(row=68;row<(25*20)+68;row+=20)//erase all the previous values
	{
		bar(205,row,230,row+7);//erase sl.no area
		bar(265,row,300,row+7);//erase vehicle area
		bar(360,row,445,row+7);//erase fuel area
		bar(510,row,595,row+7);//erase wait time area
	}
	setfillstyle(SOLID_FILL,WHITE);
	bar(541,565,589,584);//erase the page number area;
	sprintf(pno,"Page:%d",pageno+1);
	outtextxy(543,570,pno);//print page number;
	for(curr_veh=pageno*25,row=68;curr_veh<endloc;curr_veh++,row+=20)
		{
			repfile.read( (char*)&rec,sizeof(rec));
			sprintf(slno,"%d",curr_veh+1);
			if(rec.vehtype==bike)
				sprintf(veh,"Bike");
			if(rec.vehtype==car)
				sprintf(veh,"Car");
			if(rec.vehtype==jeep)
				sprintf(veh,"Jeep");
			sprintf(fuel,"%2d Litre(s)",rec.fuel_consumed);
			sprintf(wait,"%2d sec(s)",rec.waiting_time);
			outtextxy(205,row,slno);//print values
			outtextxy(265,row,veh);
			outtextxy(360,row,fuel);
			outtextxy(510,row,wait);
		}
  repfile.close();
}

void Report_generator::Display_graph()
{
	HideMouse();
	setfillstyle(SOLID_FILL,CYAN);
	floodfill(0,0,RED);
	cmdbutton returnbutton;
	returnbutton.show(650,550,710,580,"Return");
	int bikes_fuel=0,cars_fuel=0,jeeps_fuel=0;
	repfile.open("report.dat",ios::in|ios::binary);
	repfile.seekg(0,ios::beg);//seek the starting point of the report
	for(int curr_veh=0;curr_veh<total_veh;curr_veh++)//read the file and calculate the summary
	{
		repfile.read( (char*)&rec,sizeof(rec));
		if(rec.vehtype==bike)
		bikes_fuel+=rec.fuel_consumed;
		if(rec.vehtype==car)
		cars_fuel+=rec.fuel_consumed;
		if(rec.vehtype==jeep)
		jeeps_fuel+=rec.fuel_consumed;
	}
	setcolor(BLACK);
	line(100,50,100,500); //x coord
	line(100,500,750,500); //y coord
	char str[4];
	int val=25;
	int gval[3];
	char gstr[3][10]={"Bikes","Cars","Jeeps"};
	gval[0]=bikes_fuel;
	gval[1]=cars_fuel;
	gval[2]=jeeps_fuel;
	for (int unit=475;unit>=100;unit-=25,val+=25)
	{
		line(95,unit,105,unit);
		itoa(val,str,10);
		outtextxy(70,unit-3,str);
	}

	int xpos=100;
	for(int i=0;i<3;i++)
	{
		setfillstyle(LINE_FILL,0x45);
		xpos+=100;
		bar3d(xpos,500-1,xpos+100,500-gval[i],20,1);
		outtextxy(xpos+50,525,gstr[i]);
		xpos+=100;
	}
	outtextxy(300,50,"FUEL CONSUMPTION GRAPH");
	settextstyle(1,1,1);
	outtextxy(30,300,"Litres");
	ShowMouse();
	while(!returnbutton.mouseclick());
	repfile.close();
}

void Report_generator::Display_details()
{
	windows details_window;
	cmdbutton left,right,closebutton;
	HideMouse();
	details_window.show(170,5,620,590,"Vehicle Details");
	closebutton.show(604,7,619,19,"x");
	left.show(520,565,540,585,"");
	right.show(590,565,610,585,"");
	setfillstyle(SOLID_FILL,WHITE);
	bar(541,565,589,584);
	setfillstyle(SOLID_FILL,BLACK);
	bar(185,40,610,42);//top one
	bar(185,60,610,62);//top two
	line(185,40,185,560);//left
	line(610,40,610,560);//right
	bar(185,560,610,562);//bottom
	setfillstyle(SOLID_FILL,79);
	floodfill(195,45,BLACK);
	line(245,40,245,560);//column 1
	line(335,40,335,560);//column 2
	line(490,40,490,560);//column 3
	setcolor(104);
	outtextxy(190,48,"Sl. No.");
	outtextxy(260,48,"Vehicle");
	outtextxy(360,48,"Fuel Consumed");
	outtextxy(500,48,"Waiting Time");
	for(int y=80;y<580;y+=20)//draw the table lines
	line(185,y,610,y);
	int rem_vehs,page=0;
	if(total_veh<26)
	{
		Display_reportpage(page,total_veh);
		rem_vehs=total_veh-25;
	}
	else
	{
		Display_reportpage(page,25);
		rem_vehs=total_veh-25;
	}
	ShowMouse();
	while(!closebutton.mouseclick())
	{
		if(right.mouseclick())
		{
			if(rem_vehs>25)
			{
				page++;
				Display_reportpage(page,25);
				rem_vehs-=25;
			}
			else
			if(rem_vehs>0)
			{
				page++;
				Display_reportpage(page,rem_vehs);
				rem_vehs-=25;
			}
		}
		if(left.mouseclick()&&page>0)
		{
			page--;
			Display_reportpage(page,25);
			rem_vehs+=25;
		}
	}

}

int current_time()//returns the current time in terms of seconds passed since midnight
{
	return(*curr_time/18.2); //18.2=no of clock ticks per second
}

int huge DetectVGA256()
{
	return 3;//indicates the resolution 800x600
}

void Print_Station_status()
{
	char vnum[5],fuel_remaining[5];
	itoa(Options::tank_capacity,fuel_remaining,10);
	itoa(total_veh,vnum,10);
	setfillstyle(SOLID_FILL,138);//for erasing the previous values
	setcolor(WHITE);
	bar(425,550,450,560);
	bar(420,518,440,530);//erase previous value of total vehicles
	outtextxy(425,520,vnum);//print new value of total vehicles
	outtextxy(425,550,fuel_remaining);
}


