//The Gui Classes definitions for Petrol Station Simulation Project
class windows
{
	public: void show(int,int,int,int,char*);
};

void windows::show(int x1,int y1,int x2, int y2,char *title)
{
	setfillstyle(SOLID_FILL,CYAN);
	floodfill(0,0,RED);
	setlinestyle(SOLID_LINE,1,3);
	line(x1+1,y2+1,x2+1,y2+1);
	line(x2+1,y1+1,x2+1,y2+1);
	setlinestyle(SOLID_LINE,1,1);
	setfillstyle(SOLID_FILL,LIGHTGRAY);
	bar(x1,y1,x2,y2);//window color
	setfillstyle(SOLID_FILL,BLUE);
	bar(x1,y1,x2,y1+15);//title bar
	settextstyle(14,0,1);
	setcolor(WHITE);
	outtextxy(x1+5,y1+5,title);
	line(x1,y1,x2,y1);
	line(x1,y1,x1,y2);
	setcolor(DARKGRAY);
}

class cmdbutton
{
	int x1,y1,x2,y2;
	int tx,ty;//coordinates for printing the command label
	char *label;
	public:
		void show(int,int,int,int,char*);
		int mouseclick();
};

void cmdbutton::show(int cx1,int cy1,int cx2,int cy2,char *str)
{
	setfillstyle(SOLID_FILL,LIGHTGRAY);//the command button color fill
	bar(cx1,cy1,cx2,cy2); //draw close button
	setcolor(WHITE);
	line(cx1,cy1,cx2,cy1);// top line
	line(cx1,cy1,cx1,cy2);// left line
	setcolor(0);
	line(cx2,cy1,cx2,cy2);//right line
	line(cx1,cy2,cx2,cy2);//bottom line
	x1=cx1;
	x2=cx2;
	y1=cy1;
	y2=cy2;
	label=str;
	setcolor(BLACK);
	tx=x1+((x2-x1)/2); //get center x value
	ty=y1+((y2-y1)/2); //get center y value
	settextjustify(1,1); //center justify
	settextstyle(14,0,2);
	outtextxy(tx,ty,label);
	settextjustify(0,2);//set back to default justify
}

int cmdbutton::mouseclick()
{
	if(_b==1 && _x>=x1 &&_x<=x2 && _y>=y1 && _y<=y2)
	{
		HideMouse();
		setcolor(0);
		line(x1,y1,x2,y1);// top  button line
		line(x1,y1,x1,y2);// left button line
		setcolor(WHITE);
		line(x2,y1,x2,y2);//right line
		line(x1,y2,x2,y2);//bottom line
		settextjustify(CENTER_TEXT,CENTER_TEXT); //center justify
		settextstyle(14,0,2);
		setcolor(LIGHTGRAY);
		outtextxy(tx,ty,label);//erase label
		setcolor(0);
		outtextxy(tx+1,ty+1,label);//print label in new positon
		ShowMouse();
		while(_b==1);  //wait until the mouse click is released
		HideMouse();
		setcolor(WHITE);
		line(x1,y1,x2,y1);// top  button line
		line(x1,y1,x1,y2);// left button line
		setcolor(0);
		line(x2,y1,x2,y2);//right line
		line(x1,y2,x2,y2);//bottom line
		setcolor(LIGHTGRAY);
		outtextxy(tx+1,ty+1,label);//erase the label
		setcolor(0);
		outtextxy(tx,ty,label);//restore label to previos position
		settextjustify(0,2);//set back to default justify
		ShowMouse();
		return 1;
	}
	else
		return 0;
}

class optionbutton
{
	int x,y;
	public:
		void showbutton(int,int);
		void select();
		void unselect();
		int mouseclick();
};

void optionbutton::showbutton(int ox,int oy)
{
	setcolor(DARKGRAY);
	circle(ox,oy,4);
	setfillstyle(SOLID_FILL,WHITE);
	floodfill(ox,oy,DARKGRAY);
	x=ox;
	y=oy;
}

void optionbutton::select()
{
	setcolor(0);
	circle(x,y,2);
	setfillstyle(SOLID_FILL,0);
	floodfill(x,y,0);
}

void optionbutton::unselect()
{
	setfillstyle(SOLID_FILL,WHITE);
	floodfill(x,y,DARKGRAY);
}

int optionbutton::mouseclick()
{
	if( _b==1 && _x>x-5 && _x<x+5 && _y>y-5 && _y<y+5 )  //if mouse clicked on the option button
	{
		while(_b==1);  //wait until the mouse click is released
		return 1;
	}
	else
		return 0;
}



