/*Program   : TEXT Editor
Description : a simple english/farsi text editor with basic editing tools
Programmer  : Mahdi Hashemi nezhad
Last Update : 2 Sep 2002*/

#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <bios.h>

#define Ad (unsigned char far *)0xb8000000
#define Pos(y,x) (2*((y)*80+x))
#define Write(y,x,ch) *(Ad+Pos(y,x))=ch
#define WriteA(y,x,fb) *(Ad+1+Pos(y,x))=fb

struct lines_st{
	struct lines_st *next,*prev;
	char s[256];};
struct files_st{
	struct files_st *next,*prev;
	int x1,x2,mx,x0;
	int y1,y2,my,y0,ymax;
	int tx1,tx2,ty1,ty2;
	int bx1,bx2,by1,by2;
	struct lines_st*start,*p,*ps;
	char fname[256];} *file_cur=NULL,*tf,*ti;

int bx1=0,bx2=0;
int by1=0,by2=0;
int x1,x2,mx,x0;
int y1,y2,my,y0,ymax;
int tx1=x1,tx2=x2,ty1=y1,ty2=y2;
struct lines_st*start=NULL,*bstart=NULL,*p=NULL,*ps=NULL,*h;
char fname[256];

FILE *fp;
int n=0,ins=1,quit=0,farmode=0,showtime=1,tabsize=4,modifiers;
char sstr[35]="",scr[4000],tscr[4000],
farsi[]="!\"#$%:x()+-=ꡟ௥<>./",
eng[]="!@#$%^&*()_+0123456789-=`qwertop[]\\';lkjgfdsazxcvbnm,~QWERTYUIOP{}|\":LKJHGFDSAZXCVBNM<>?./",
lowf[]="",
upf[]="",
spf[]="௎",
menuhot[11]="",
menustr[5][12][24]={
	{"~File","~New      Ctrl+N","~Open...      F3","_~Save         F2","_S~ave as...","_Save A~ll","-","_~Print","~DOS shell","-","~Quit      Alt-X"},
	{"~Edit","_Cu~t     Shift+Del","_~Copy     Ctrl+Ins","_~Paste   Shift+Ins","_C~lear    Ctrl+Del"},
	{"~Search","_~Find               F7","_~Replace","_~Search again  Ctrl+F7"},
	{"~Window",	"_~Size/Move   Ctrl+F5","_~Zoom             F5","_Ne~xt             F6","_~Close        Alt+F3","_Close a~ll"},
	{"~Options","","","-","~About       F1"}};

char label(int x,int y,char s[],int len,int sw);
char upper(char);
int showmenu(int a,int b);
void getchoice(int*,int*,int);
void menu(int);
//------
void intro();
struct lines_st*load(FILE*,int*);
int save(FILE*,struct lines_st*);
void show(struct lines_st *,int,int,int,int,int,int,int,int,int);
void draw_window(int,int,int,int,char,char);
void freelist(struct lines_st*);
void add(char*,int,unsigned char);
void rep(char*,int,unsigned char);
void savescr(char*);
void loadscr(char*);
void print(int,int,char*,char);
void printtop(){int i;for(i=0;i<80;i++)WriteA(0,i,0x77);for(i=0;i<5;i++)label(10*i+2,0,menustr[i][0],10,0);}
void printbot(){print(0,24,"  Ctrl-N New   F2 Save   F3 Open   F6 Next   F7 Find   Ctrl-F5 Size   F10 Menu  ",0x70);}
void printbot1(){char s[81];sprintf(s,"  %c%c%c%c Move   Shift-%c%c%c%c Resize    Done                                     ",24,25,27,26,24,25,27,26);print(0,24,s,0x70);}
void printtag(int x1,int x2,int y1,char s[]){print(x1+(x2-x1-strlen(s))/2,y1,strupr(s),0x1F);}
void convtab(char*);
void mainscr(){for(int i=160;i<4000-160;i+=2){*(Ad+i)='';*(Ad+i+1)=0x71;}}
unsigned char getkey();
void message(char*,char*,char);
int getstr(char s0[],char s[]);
int findstr(char*s1,char*s2,int i);
void putdata(struct files_st*);
void openfile();
void find1st();
int find2nd();
void replace();
void nextwindow();
void closewindow();
void closeall();
void zoom();
void resize();
void showcursor();
void hidecursor();
void newfile();
void saveas();
void saveall();
void savefile();
void printfile();
//----------------
void home();
void end();
void right();
void left();
void up();
void down();
void pageup();
void pagedown();
void del();
void tab();
void backspace();
void enter();
void addengchar(unsigned char);
void addfarchar(unsigned char);
//---
void block(int direction);
void copyblock();
void clearblock();
void pasteblock();

void main()
{
	int i,j,editcommand,extended;
	mainscr();
	printtop();
	printbot();
	savescr(scr);
	hidecursor();
	unsigned char ch;
	ch=getkey();
	while(!quit)
	{
		editcommand=0;
		extended=0;
		switch(ch)
		{
			case 0:
				ch=getch();
				extended=1;
				switch(ch)
				{
					case 59://F1
						intro();
					break;
					case 45://Alt-X
						quit=1;
					break;
					case 68://F10
					case 33://Alt-F
						menu(0);
					break;
					case 18://Alt-E
						menu(1);
					break;
					case 31://Alt-S
						menu(2);
					break;
					case 17://Alt-W
						menu(3);
					break;
					case 24://Alt-O
						menu(4);
					break;
					case 61://F3
						openfile();
					break;
					default:
						editcommand=1;
				}
			break;
			case 14://Ctrl+N
				newfile();
			break;
			default:
				editcommand=1;
		}
		if(editcommand&&file_cur)
		if(extended)
		{
			switch(ch)
			{
				case 134://F1
					farmode=!farmode;
				break;
				case 64://F6
					nextwindow();
				break;
				case 106://Alt+F3
					closewindow();
				break;
				case 65://F7
					find1st();
				break;
				case 100://Ctrl+F7
					find2nd();
				break;
				case 95://Ctrl+F2
					saveas();
				break;
				case 60://F2
					savefile();
				break;
				case 63://F5
					zoom();
				break;
				case 98://Ctrl+F5
					resize();
				break;
				case 71://HOME
					if(modifiers&0x03)
						block(7);
					else
						home();
				break;
				case 79://END
					if(modifiers&0x03)
						block(8);
					else
						end();
				break;
				case 75://LEFT
					if(modifiers&0x03)
						block(3);
					else
						left();
				break;
				case 77://RIGHT
					if(modifiers&0x03)
						block(4);
					else
						right();
				break;
				case 72://UP
					if(modifiers&0x03)
						block(1);
					else
						up();
				break;
				case 80://DOWN
					if(modifiers&0x03)
						block(2);
					else
						down();
				break;
				case 73://PAGE UP
					if(modifiers&0x03)
						block(5);
					else
						pageup();
				break;
				case 81://PAGE DOWN
					if(modifiers&0x03)
						block(6);
					else
						pagedown();
				break;
				case 82://INS
					if(modifiers&0x03)
						pasteblock();
					else
						ins=!ins;
				break;
				case 83://DEL
					if(modifiers&0x03)
					{
						copyblock();
						clearblock();
					}
					else
						del();
				break;
				case 146://Ctrl-INS
					copyblock();
				break;
				case 147://Ctrl-DEL
					clearblock();
				break;
			}
		}
		else
		switch(ch)
		{
			case 9://Tab
				tab();
			break;
			case 8://BackSpace
				backspace();
			break;
			case 13://Enter
				enter();
			break;
			case 16://Ctrl+P
				if((ch=getkey())==0)
					ch=getkey();
				addengchar(ch);
			break;
			default:
			if(farmode)
				addfarchar(ch);
			else
				addengchar(ch);
		}
		if(file_cur)
		{
			show(ps,x0,mx,y0,my,ymax,x1,y1,x2,y2);
			showcursor();
		}
		else hidecursor();
		if(!quit)ch=getkey();
	}
//-----------------------------------------
	//free all the memory
	closeall();
	freelist(bstart);
	clrscr();
	gotoxy(1,1);
	showcursor();
}
//------------------------
void hidecursor()
{
	_AH=1;_CH=32;_CL=32;
	asm int 10h
}
//------------------------
void showcursor()
{
	_AH=1;
	if(farmode){_CH=2;_CL=3;}
	else{_CH=ins?8:1;_CL=9;}
	asm int 10h
}
//-------------------------
unsigned char getkey()
{
	static struct time t;
	static char s[9];
	while(!kbhit())
	{
		gettime(&t);
		sprintf(s,"%2d:%02d:%02d",t.ti_hour, t.ti_min, t.ti_sec);
		print(70,0,showtime?s:"        ",0x71);
	}
	modifiers = bioskey(2);
	return(getch());
}
//------------------------
void print(int x,int y,char s[],char color)
{
	int i;
	for(i=0;s[i];i++)
	{
		Write(y,x+i,s[i]);
		WriteA(y,x+i,color);
	}
}
//------------------------
void draw_window(int x1,int y1,int x2,int y2,char color1,char color2)
{
	int i,j;
	for(i=y1+1;i<y2;i++)
		for(j=x1+1;j<x2;j++)
			WriteA(i,j,color1);
	for(i=x1+1;i<x2;i++)
	{
		Write(y1,i,'');
		WriteA(y1,i,color2);
		Write(y2,i,'');
		WriteA(y2,i,color2);
	}
	for(i=y1+1;i<y2;i++)
	{
		Write(i,x1,'');
		WriteA(i,x1,color2);
		Write(i,x2,'');
		WriteA(i,x2,color2);
	}
	Write(y1,x1,'');
	WriteA(y1,x1,color2);
	Write(y1,x2,'');
	WriteA(y1,x2,color2);
	Write(y2,x1,'');
	WriteA(y2,x1,color2);
	Write(y2,x2,'');
	WriteA(y2,x2,color2);
	//Shadows
	if(x2<79)
		for(i=y1+1;(i<y2+2)&&(i<24);i++)
			WriteA(i,x2+1,0x08);
	if(y2<23)
		for(i=x1+2;i<x2+1;i++)
			WriteA(y2+1,i,0x08);
}
//--------------------------
//--------------------------
void show(struct lines_st *p,int x,int mx,int y,int my,int ymax,int x1,int y1,int x2,int y2)
{
	if(!file_cur)return;
	int i,j;
	for(i=y1+1;i<y2;i++)
		for(j=x1+1;j<x2;j++)
			if( //begin of condition
				((by1<i+(y0-y1-1)&&i+(y0-y1-1)<by2))||
				(by1!=by2&&(by1==i+(y0-y1-1))&&(bx1<j+(x0-x1)))||
				(by1!=by2&&(by2==i+(y0-y1-1))&&(bx2>=j+(x0-x1)))||
				(by1==by2&&(by1==i+(y0-y1-1))&&(bx1<j+(x0-x1))&&(bx2>=j+(x0-x1)))
				)//end of condition
				WriteA(i,j,0x71);
			else
				WriteA(i,j,0x1e);
	gotoxy(mx+x1+2-x,my+y1+2-y);
	int size;
	char s[10];
	sprintf(s," %3d:%3d ",my+1,mx+1);
	for(i=0;s[i];i++)
		Write(y2,x1+3+i,s[i]);
	for(i=y1;i<y2-1&&p;i++)
	{
		size=strlen(p->s);
		for(j=0;j<(x2-1-x1)&&j<size-x;j++)
			Write(i+1,j+1+x1,p->s[j+x]);
		for(;j<x2-1-x1;j++)
			Write(i+1,j+1+x1,' ');
		p=p->next;
	}
	for(;i<y2-1;i++)
		for(j=x1;j<x2-1;j++)
			Write(i+1,j+1,' ');

	Write(y1+1,x2,'');
	WriteA(y1+1,x2,0x31);
	Write(y2-1,x2,'');
	WriteA(y2-1,x2,0x31);
	for(i=y1+2;i<y2-1;i++)
	{
		Write(i,x2,'');
		WriteA(i,x2,0x31);
	}
	//y=(y2-y1-4)*((my+1)/(float)ymax)+y1+2;
	y=(y2-y1-3)*((my)/(float)ymax)+y1+2;
	Write(y,x2,'');
}
//------------------
void intro()
{
	hidecursor();
	savescr(tscr);
	int i,j;
	draw_window(20,8,60,17,0x1e,0x1f);
	for(i=9;i<17;i++)
		for(j=21;j<60;j++)
			Write(i,j,' ');
	print(22,9, " Program    : Text Editor            ",0x3e);
	print(22,10," Programmer : Mahdi Hashemi nezhad   ",0x31);
	print(22,11," Special thanks to : ",0x31);
	print(42,11," Mr.Yazdanjoo    ",0x35);
	print(31,12," Sadjad University ",0x1e);
	print(23,13, " This is the final project of the",0x17);
	print(25,14, "\"Advanced Programming\"",0x1f);
	print(48,14, "Course",0x17);
	print(27,16, " Last Update : 2 Sep 2002 ",0x3f);
	if(!getkey())getkey();
	loadscr(tscr);
	showcursor();
}
//------------------
struct lines_st*load(FILE*fp,int*y)
{
	char s[256];
	struct lines_st *p,*q,*start=NULL;
	*y=0;
	if(!feof(fp))
	{
		p=(struct lines_st*)malloc(sizeof(struct lines_st));
		if(!fgets(s,256,fp))p->s[0]=0;
		convtab(s);
		strcpy(p->s,s);
		p->next=NULL;
		p->prev=NULL;
		start=p;
		(*y)++;
	}
	while(!feof(fp))
	{
		if((p->s[strlen(p->s)-1])==10)
			p->s[strlen(p->s)-1]=0;
		q=p;
		p=(struct lines_st*)malloc(sizeof(struct lines_st));
		if(!fgets(s,256,fp))p->s[0]=0;
		convtab(s);
		strcpy(p->s,s);
		p->prev=q;
		q->next=p;
		(*y)++;
	}
	if((p->s[strlen(p->s)-1])==10)
		p->s[strlen(p->s)-1]=0;
	p->next=NULL;
	return start;
}
//------------------
//------------------
int save(FILE*fp,struct lines_st*p)
{
	int sw=1;
	while(p)
	{
		if(fputs(p->s,fp)==EOF)sw=0;
		if(p->next)fputs("\n",fp);
		p=p->next;
	}
	return sw;
}
//------------------
//------------------
void freelist(struct lines_st*p)
{
	struct lines_st*q;
	while(p)
	{
		q=p->next;
		free(p);
		p=q;
	}
}
//-----------------------
void freeall()
{
	if(file_cur)
	{
		tf=file_cur->next;
		while(tf!=file_cur)
		{
			ti=tf->next;
			freelist(tf->start);
			free(tf);
			tf=ti;
		}
		freelist(file_cur->start);
		free(file_cur);
	}
}
//-----------------------
//-----------------------
void add(char s[],int x,unsigned char ch)
{
	int i;
	for(i=strlen(s)+1;i>x;i--)
		s[i]=s[i-1];
	s[i]=ch;
	s[255]=0;
}
//-----------------------
void rep(char s[],int x,unsigned char ch)
{
	if(!s[x])s[x+1]=0;
	s[x]=ch;
}
//-------------------
void savescr(char s[])
{
	int i;
	for(i=0;i<4000;i++)
		s[i]=*(Ad+i);
}
//-------------------
void loadscr(char s[])
{
	int i;
	for(i=0;i<4000-160;i++)
		*(Ad+i)=s[i];
}
//---------------------
void convtab(char s[])
{
	int i,j;
	for(i=0;i<strlen(s);i++)
		if(s[i]==9)
		{
			for(j=strlen(s)+tabsize;j>i;j--)
				s[j+tabsize-1]=s[j];
			for(j=0;j<tabsize;j++)
				s[i+j]=' ';
			i+=tabsize-1;
		}
	s[255]=0;
}
//-------------------------------
void message(char s1[],char s2[],char color)
{
	savescr(tscr);
	int i,j;
	for(i=10;i<13;i++)
		for(j=37-strlen(s2)/2+1;j<43+strlen(s2)/2;j++)
			Write(i,j,' ');
	hidecursor();
	draw_window(37-strlen(s2)/2,9,43+strlen(s2)/2,13,0x7f,0x7f);
	print(40-strlen(s2)/2,11,s2,color);
	print(40-strlen(s1)/2,9,s1,0x72);
	if(!getkey())getkey();
	showcursor();
	loadscr(tscr);
}
//------------------------------
int getstr(char s0[],char s[])
{
	showcursor();
	savescr(tscr);
	int i,j,p=0;
	for(i=9;i<13;i++)
		for(j=21;j<60;j++)
			Write(i,j,' ');
	s[34]=0;
	p=strlen(s);
	unsigned char ch;
	draw_window(20,8,60,13,0x7f,0x7f);
	print(24,10,s0,0x70);
	for(i=0;i<35;i++)
			WriteA(11,23+i,0x2e);
	do
	{
		for(i=0;i<strlen(s);i++)
			Write(11,23+i,s[i]);
		for(;i<35;i++)
			Write(11,23+i,' ');
		gotoxy(24+p,12);
		ch=getkey();
		switch(ch)
		{
			case 0://Extended keys
				ch=getkey();
			case 13://Enter
			case 27://ESC
			case 9://Tab
			break;
			case 8:
				if(p>0)s[--p]=0;
			break;
			default:
				if(p<34)
				{
					s[p++]=ch;
					s[p]=0;
				}
		}
	}while((ch!=27)&&(ch!=13));
	loadscr(tscr);
	return(p&&(ch!=27));
}
//------------------------------
int findstr(char*s1,char*s2,int i)
{
	if(!file_cur)return 0;
	int j=0;
	for(;strlen(s1)>i&&s2[j];i++)
		for(j=0;(s2[j])&&(s1[i+j]==s2[j]);j++);
	return (*(s2+j)?0:i);
}
//-----------------------------
void putdata(struct files_st*h)
{
	h->x1=x1;
	h->x2=x2;
	h->mx=mx;
	h->x0=x0;
	h->y1=y1;
	h->y2=y2;
	h->my=my;
	h->y0=y0;
	h->bx1=bx1;
	h->bx2=bx2;
	h->by1=by1;
	h->by2=by2;
	h->ymax=ymax;
	h->start=start;
	h->p=p;
	h->ps=ps;
	strcpy(h->fname,fname);
}
//-----------------------------
void getdata(struct files_st*h)
{
	x1=h->x1;
	x2=h->x2;
	mx=h->mx;
	x0=h->x0;
	y1=h->y1;
	y2=h->y2;
	my=h->my;
	y0=h->y0;
	bx1=h->bx1;
	bx2=h->bx2;
	by1=h->by1;
	by2=h->by2;
	ymax=h->ymax;
	start=h->start;
	p=h->p;
	ps=h->ps;
	strcpy(fname,h->fname);
}
//-----------------------------
void openfile()
{
	char tfname[256]="";
	if(!getstr("File to open:",tfname))return;
	if(!(fp=fopen(tfname,"r")))
	{
		message(" Error "," File not found! ",0x02);
		return;
	}
	if(file_cur)
	{
		show(ps,x0,mx,y0,my,ymax,x1,y1,x2,y2);
		draw_window(x1,y1,x2,y2,0x17,0x17);
		printtag(x1,x2,y1,fname);
		//-------------------
		putdata(file_cur);
		//-------------------
	}
	savescr(scr);
	strcpy(fname,tfname);
	start=load(fp,&ymax);
	if(file_cur)
	{
		if(((x2-x1)>strlen(fname)+2)&&((x2-x1)>15))
			x1++;
		if(y2-y1>4)
			y1++;
		tx1=x1;
		tx2=x2;
		ty1=y1;
		ty2=y2;
	}
	else
	{
		x1=0;x2=79;y1=1;y2=23;
		tx1=0;tx2=0;ty1=0;ty2=0;
	}
	bx1=0;
	bx2=0;
	by1=0;
	by2=0;
	y0=0;
	x0=0;
	my=0;
	mx=0;
	p=start;
	ps=start;
	//-------------------
	tf=(struct files_st*)malloc(sizeof(struct files_st));
	if(file_cur)
	{
		(file_cur->next)->prev=tf;
		tf->next=file_cur->next;
		file_cur->next=tf;
		tf->prev=file_cur;
	}
	else
	{
		tf->next=tf;
		tf->prev=tf;
	}
	putdata(tf);
	file_cur=tf;
	//-------------------
	draw_window(x1,y1,x2,y2,0x1e,0x1f);
	printtag(x1,x2,y1,fname);
	show(ps,x0,mx,y0,my,ymax,x1,y1,x2,y2);
}
//---------------------------
void replace()
{
	if(!file_cur)return;
	int i,j,l;
	char s0[35]="",tmp[256];
	if(!getstr("Text to find:",sstr))return;
	if(!getstr("Text to replace:",s0))return;
	if(!find2nd())return;
	l=strlen(sstr);
	for(i=0;*(p->s+mx+l+i);i++)
		*(tmp+i)=*(p->s+mx+l+i);
	*(tmp+i)=0;
	for(i=0;*(s0+i);i++)
		*(p->s+mx+i)=*(s0+i);
	for(j=0;*(tmp+j);j++)
		*(p->s+mx+i+j)=*(tmp+j);
	*(p->s+mx+i+j)=0;
	by1=my;by2=my;
	bx1=mx;bx2=mx+strlen(s0);
}
//---------------------------
void find1st()
{
	if(!file_cur)return;
	if(getstr("Text to find:",sstr))
		find2nd();
}
//---------------------------
int find2nd()
{
	if(!file_cur)return 0;
	int i,j;
	if(strlen(sstr)>0)
	{
		h=p;
		i=mx+1;
		j=0;
		while(!(i=findstr(h->s,sstr,i))&&h)
		{
			h=h->next;
			j++;
		}
		if(i)
		{
			mx=i-1;
			my+=j;
			p=h;
			if(x0-2<mx-(x2-x1))
				x0=mx-(x2-x1)+2;
			if(x0>mx)x0=mx;
				while(my+2>y0+(y2-y1))
				{
					y0++;
					ps=ps->next;
				}
				by1=my;by2=my;
				bx1=mx;bx2=mx+strlen(sstr);
			return(1);
		}
		message(" Error "," Search string not found! ",0x70);
		return(0);
	}
	return(0);
}
//-----------------------
void nextwindow()
{
	if(file_cur)
	{
		show(ps,x0,mx,y0,my,ymax,x1,y1,x2,y2);
		draw_window(x1,y1,x2,y2,0x17,0x17);
		printtag(x1,x2,y1,fname);
		savescr(scr);
		//-------------------
		putdata(file_cur);
		//-------------------
		file_cur=file_cur->next;
		//-------------------
		getdata(file_cur);
		//-------------------
		draw_window(x1,y1,x2,y2,0x1e,0x1f);
		printtag(x1,x2,y1,fname);
		show(ps,x0,mx,y0,my,ymax,x1,y1,x2,y2);
	}
}
//-------------------------
void closeall()
{
	if(!file_cur)return;
	tf=file_cur->prev;
	while(tf!=file_cur)
	{
		closewindow();
		file_cur=file_cur->next;
	}
	closewindow();
}
//--------------------------
void closewindow()
{
	if(!file_cur)return;
	if(file_cur->next!=file_cur)
	{
		tf=file_cur;
		file_cur=tf->prev;
		(tf->next)->prev=tf->prev;
		(tf->prev)->next=tf->next;
		freelist(tf->start);
		free(tf);
		//-------------------
		getdata(file_cur);
		//-------------------
		mainscr();
		for(tf=file_cur->next;tf!=file_cur;tf=tf->next)
		{
			show(tf->ps,tf->x0,tf->mx,tf->y0,tf->my,tf->ymax,tf->x1,tf->y1,tf->x2,tf->y2);
			draw_window(tf->x1,tf->y1,tf->x2,tf->y2,0x17,0x17);
			printtag(tf->x1,tf->x2,tf->y1,tf->fname);
		}
		savescr(scr);
		draw_window(tf->x1,tf->y1,tf->x2,tf->y2,0x1e,0x1f);
		printtag(tf->x1,tf->x2,tf->y1,tf->fname);
		show(tf->ps,tf->x0,tf->mx,tf->y0,tf->my,tf->ymax,tf->x1,tf->y1,tf->x2,tf->y2);
	}
	else
	{
		freelist(file_cur->start);
		free(file_cur);
		file_cur=NULL;
		mainscr();
		savescr(scr);
	}
}
//--------------------------------
void zoom()
{
	if(!file_cur)return;
	if((x1==0)&&(x2==79)&&(y1==1)&&(y2==23))
	{
		x1=tx1;
		x2=tx2;
		y1=ty1;
		y2=ty2;
		if(x0-2<mx-(x2-x1))
			x0=mx-(x2-x1)+2;
		while(my+2>y0+(y2-y1))
		{
			y0++;
			ps=ps->next;
		}
	}
	else
	{
		tx1=x1;
		tx2=x2;
		ty1=y1;
		ty2=y2;
		x1=0;
		x2=79;
		y1=1;
		y2=23;
	}
	loadscr(scr);
	show(ps,x0,mx,y0,my,ymax,x1,y1,x2,y2);
	draw_window(x1,y1,x2,y2,0x1e,0x1f);
	printtag(x1,x2,y1,fname);
}
//------------------------
void resize()
{
	if(!file_cur)return;
	unsigned char ch;
	printbot1();
	hidecursor();
	//--------------------------
	mainscr();
	for(tf=file_cur->next;tf!=file_cur;tf=tf->next)
	{
		show(tf->ps,tf->x0,tf->mx,tf->y0,tf->my,tf->ymax,tf->x1,tf->y1,tf->x2,tf->y2);
		draw_window(tf->x1,tf->y1,tf->x2,tf->y2,0x17,0x17);
		printtag(tf->x1,tf->x2,tf->y1,tf->fname);
	}
	savescr(scr);
	draw_window(tf->x1,tf->y1,tf->x2,tf->y2,0x1e,0x1f);
	printtag(tf->x1,tf->x2,tf->y1,tf->fname);
	show(tf->ps,tf->x0,tf->mx,tf->y0,tf->my,tf->ymax,tf->x1,tf->y1,tf->x2,tf->y2);
	//-------------------------
	do
	{
		loadscr(scr);
		show(ps,x0,mx,y0,my,ymax,x1,y1,x2,y2);
		draw_window(x1,y1,x2,y2,0x1e,0x13);
		ch=getkey();
		if(!ch)
		{
			ch=getch();
			switch(ch)
			{
				case 72://up
					if(modifiers&0x03)
					{
						if(y2-y1>4)
							y2--;
					}
					else
						if(y1>1)
						{
							y1--;
							y2--;
						}
				break;
				case 80://down
					if(modifiers&0x03)
					{
						if(y2<23)
							y2++;
					}
					else
						if(y2<23)
						{
							y1++;
							y2++;
						}
				break;
				case 75://left
					if(modifiers&0x03)
					{
						if(((x2-x1)>strlen(fname)+2)&&((x2-x1)>15))
							x2--;
					}
					else
						if(x1)
						{
							x1--;
							x2--;
						}
				break;
				case 77://right
					if(modifiers&0x03)
					{
						if(x2<79)
							x2++;
					}
					else
						if(x2<79)
						{
							x1++;
							x2++;
						}
				break;
			}
		}
	}while((ch!=13)&&(ch!=27));
	if(x0-2<mx-(x2-x1))
		x0=mx-(x2-x1)+2;
	while(my+2>y0+(y2-y1))
	{
		y0++;
		ps=ps->next;
	}
	printbot();
	draw_window(x1,y1,x2,y2,0x1e,0x1f);
	printtag(x1,x2,y1,fname);
	showcursor();
}
//-------------------------------
void newfile()
{
	if(file_cur)
	{
		show(ps,x0,mx,y0,my,ymax,x1,y1,x2,y2);
		draw_window(x1,y1,x2,y2,0x17,0x17);
		printtag(x1,x2,y1,fname);
		//-------------------
		putdata(file_cur);
		//-------------------
	}
	savescr(scr);
	start=(struct lines_st*)malloc(sizeof(struct lines_st));
	start->s[0]=0;
	start->prev=NULL;
	start->next=NULL;
	sprintf(fname,"NONAME%02d.TXT",n++);
	if(file_cur)
	{
		if(((x2-x1)>strlen(fname)+2)&&((x2-x1)>15))
			x1++;
		if(y2-y1>4)
			y1++;
	}
	else
		{x1=0;x2=79;y1=1;y2=23;}
	tx1=x1;
	tx2=x2;
	ty1=y1;
	ty2=y2;
	bx1=0;
	bx2=0;
	by1=0;
	by2=0;
	y0=0;
	x0=0;
	my=0;
	mx=0;
	ymax=1;
	p=start;
	ps=start;
	//-------------------
	tf=(struct files_st*)malloc(sizeof(struct files_st));
	if(file_cur)
	{
		(file_cur->next)->prev=tf;
		tf->next=file_cur->next;
		file_cur->next=tf;
		tf->prev=file_cur;
	}
	else
	{
		tf->next=tf;
		tf->prev=tf;
	}
	putdata(tf);
	file_cur=tf;
	//-------------------
	draw_window(x1,y1,x2,y2,0x1e,0x1f);
	printtag(x1,x2,y1,fname);
	show(ps,x0,mx,y0,my,ymax,x1,y1,x2,y2);
}
//------------------------
void saveas()
{
	if(!file_cur)return;
	char tfname[35]="";
	if(getstr("Save File as:",tfname))
	{
		if(fopen(tfname,"a")==NULL)
		{
			message(" Error "," Bad File name! ",0x71);
			fclose(fp);
			return;
		}
		strcpy(fname,tfname);
		draw_window(x1,y1,x2,y2,0x1e,0x1f);
		printtag(x1,x2,y1,fname);
		savefile();
	}
}
//----------------------
void savefile()
{
	if(!file_cur)return;
	fp=fopen(fname,"w");
	save(fp,start);
	fclose(fp);
	message(" Message "," File was saved successfully! ",0x71);
}
//--------
void saveall()
{
	if(file_cur)
	{
		tf=file_cur->prev;
		while(tf!=file_cur)
		{
			savefile();
			file_cur=file_cur->next;
		}
		savefile();
	}
}
//------------------------------
void printfile()
{
	if(!file_cur)return;
	for(h=start;h;h=h->next)
		fprintf(stdprn,"%s\n",h->s);
}
//------------------------------
//------------------------------
void home()
{
	x0=0;
	mx=0;
}
//--------------
void end()
{
	mx=strlen(p->s);
	if(mx>254)mx=254;
	if(x0-2<mx-(x2-x1))
		x0=mx-(x2-x1)+2;
	if(x0>mx)x0=mx;
}
//----------------------------
void left()
{
	if(mx>0)mx--;
	if(x0>mx)x0=mx;
}
void right()
{
	if(mx<254)mx++;
	if(mx==x0+(x2-x1)-1)x0++;
}
void up()
{
	if(p->prev)
	{
		p=p->prev;
		if(my==y0)
		{
			ps=ps->prev;
			y0--;
		}
		my--;
	}
}
void down()
{
	if(p->next)
	{
		p=p->next;
		if(my==y0+(y2-y1)-2)
		{
			ps=ps->next;
			y0++;
		}
		my++;
	}
}
void pageup()
{
	int i;
	for(i=0;i<y2-y1-2;i++)
	if(p->prev)
	{
		p=p->prev;
		my--;
		if(ps->prev)
		{
			ps=ps->prev;
			y0--;
		}
	}
}
void pagedown()
{
	int i;
	for(i=0;i<y2-y1-2;i++)
	if(p->next)
	{
		p=p->next;
		my++;
		if(ps->next)
		{
			ps=ps->next;
			y0++;
		}
	}
}
//------------
void del()
{
	int i;
	if(mx<strlen(p->s))
	for(i=mx;i<strlen(p->s);i++)
		p->s[i]=p->s[i+1];
	else
		if(p->next)
		{
			//Add extra spaces
			if(mx>strlen(p->s))
			for(i=strlen(p->s);i<mx;i++)
				p->s[i]=' ';
			//copy next line
			for(i=0;(i<strlen((p->next)->s))&&(mx+i<255);i++)
				p->s[mx+i]=(p->next)->s[i];
			p->s[mx+i]=0;
			//delete next line
			h=p->next;
			p->next=h->next;
			if(h->next)
				(h->next)->prev=p;
			free(h);
			ymax--;
		}
}
void tab()
{
	int i;
	if(ins&&mx<strlen(p->s))
		for(i=0;i<4&&strlen(p->s)<255;i++)
		{
			add(p->s,mx,' ');
			if(mx<254)mx++;
			if(mx==x0+(x2-x1)-1)x0++;
		}
		else
		{
			mx+=tabsize;
			if(mx>254)mx=254;
			if(x0-2<mx-(x2-x1))
			x0=mx-(x2-x1)+2;
		}
}
void backspace()
{
	int i;
	if(mx)
	{
		//Add extra Spaces
		if(mx>strlen(p->s))
		{
			for(i=strlen(p->s);i<mx;i++)
				p->s[i]=' ';
			p->s[i]=0;
		}
		//delseting the letter
		mx--;
		if(x0>mx)x0=mx;
		for(i=mx;i<strlen(p->s);i++)
			p->s[i]=p->s[i+1];
		p->s[i]=0;
	}
	else
		if(p->prev)
			{
				mx=strlen((p->prev)->s);
				if(mx>254)
					mx=254;
				else
				{
					for(i=0;(p->s[i])&&(i+mx<255);i++)
						(p->prev)->s[i+mx]=p->s[i];
					(p->prev)->s[i+mx]=0;
				}
				if(x0-2<mx-(x2-x1))
					x0=mx-(x2-x1)+2;
				if(x0>mx)x0=mx;
				h=p;
				p=p->prev;
				p->next=h->next;
				if(h->next)(h->next)->prev=p;
				free(h);
				ymax--;
				if(my==y0)
				{
					ps=p;
					y0--;
				}
				my--;
			}
}
void enter()
{
	int i;
	if(ins)
	{
		h=(struct lines_st*)malloc(sizeof(struct lines_st));
		h->next=p->next;
		if(p->next)(p->next)->prev=h;
			p->next=h;
		h->prev=p;
		ymax++;
		my++;
		if(my==y0+(y2-y1)-1)
		{
			ps=ps->next;
			y0++;
		}
		//Add extra Spaces
		if(mx>strlen(p->s))
		{
			for(i=strlen(p->s);i<mx;i++)
				p->s[i]=' ';
			p->s[i]=0;
		}
		//Copy rest of line
		for(i=0;p->s[i+mx];i++)
			h->s[i]=p->s[i+mx];
		h->s[i]=0;
		p->s[mx]=0;
		mx=0;
		x0=0;
		p=h;
	}
	else
		if(p->next)
			{
				mx=0;
				my++;
				p=p->next;
				if(my==y0+(y2-y1)-1)
				{
					ps=ps->next;
					y0++;
				}
			}
}
//------------------------
void addengchar(unsigned char ch)
{
	int i;
	if(mx>strlen(p->s))
	{
		for(i=strlen(p->s);i<mx;i++)
			p->s[i]=' ';
		p->s[i]=0;
	}
	if(ins)add(p->s,mx,ch);
	else rep(p->s,mx,ch);
	if(mx<254)mx++;
	if(mx==x0+(x2-x1)-1)x0++;
}
//------------------------
void addfarchar(unsigned char ch)
{
	int i;
	if(mx>strlen(p->s))
	{
		for(i=strlen(p->s);i<mx;i++)
			p->s[i]=' ';
		p->s[i]=0;
	}
	for(i=0;eng[i]!=ch&&eng[i];i++);
	if(eng[i])
		add(p->s,mx,farsi[i]);
	else
		switch(ch)
		{
			case ' ': //space
				for(i=0;lowf[i]!=p->s[mx]&&lowf[i];i++);
				if(lowf[i]==p->s[mx])
					if(p->s[mx]=='')
					{
						for(i=0;spf[i]&&spf[i]!=p->s[mx+1];i++);
						if(spf[i])
							p->s[mx]='';
						else
							p->s[mx]='';
					}
					else
						p->s[mx]=upf[i];
				else
					add(p->s,mx,' ');
				break;
			case 'h': //
				if(p->s[mx]=='')
					p->s[mx]='';
				else
					{
						for(i=0;spf[i]&&spf[i]!=p->s[mx];i++);
						add(p->s,mx,spf[i]?'':'');
					}
				break;
			case 'i': //
				for(i=0;spf[i]&&spf[i]!=p->s[mx];i++);
				add(p->s,mx,spf[i]?'':'');
				break;
			case 'y': //
				for(i=0;spf[i]&&spf[i]!=p->s[mx];i++);
				add(p->s,mx,spf[i]?'':'');
				break;
			case 'u': //
				for(i=0;spf[i]&&spf[i]!=p->s[mx];i++);
				add(p->s,mx,spf[i]?'':'');
				break;
		}
}
//-------------------------------------------
char upper(char ch)
{
	if(ch>='a'&&ch<='z')return ch+('A'-'a');
	return ch;
}
//-------------------------------------------
char label(int x,int y,char s[],int len,int sw)
{
	char hotch=0;
	int i,x1;
	for(i=0;i<len;i++)
	{
		Write(y,x+i,' ');
		if(s[0]=='|'||(s[0]=='_'&&!file_cur))WriteA(y,x+i,sw?0x07:0x78);
		else WriteA(y,x+i,sw?0x20:0x70);
	}
	x1=x+1;
	if(strcmp(s,"-"))
		for(i=0;i<len&&s[i];i++)
			switch(s[i])
			{
				case '~':
				{
					if(s[0]!='|'&&(s[0]!='_'||file_cur))
					{
						if(s[0]=='_')WriteA(y,x+i,sw?0x24:0x74);
						else WriteA(y,x+i+1,sw?0x24:0x74);
						hotch=s[i+1];
					}
				}
				case '|':
				case '_':
				break;
				default:
					Write(y,x1++,s[i]);
			}
	else
	{
		Write(y,x-1,'');
		for(i=0;i<len;i++)
			Write(y,x+i,'');
		Write(y,x+i,'');
	}
	return upper(hotch);
}
int showmenu(int a,int b)
{
	int i,j,len,n;
	for(i=0;menustr[i+1][0][0];i++)
		label(10*i+2,0,menustr[i][0],10,a==i);
	len=0;
	for(i=1;menustr[a][i][0];i++)
		if(strlen(menustr[a][i])>len)
			len=strlen(menustr[a][i]);
	draw_window(10*a+1,1,10*a+2+len,i+1,0x70,0x70);
	for(i=1;menustr[a][i][0];i++)
		menuhot[i-1]=label(10*a+2,i+1,menustr[a][i],len,i==b);
	return i-1;
}
void getchoice(int*x1,int*x2,int a)
{
	if(!farmode)strcpy(menustr[4][1],"_~Farsi      F12");
	else strcpy(menustr[4][1],"_~English    F12");;
	if(!showtime)strcpy(menustr[4][2],"~Clock ON");
	else strcpy(menustr[4][2],"~Clock OFF");;
	if(a>4||a<0)a=0;
	int i,b=1,n;
	char ch;
	savescr(scr);
	n=showmenu(a,b);
	ch=getkey();
	while(ch!=27&&!(ch==13&&menustr[a][b][0]!='|'&&(menustr[a][b][0]!='_'||file_cur)))
	{
		if(ch==0)
		{
			ch=getch();
			switch(ch)
			{
				/*Alt-F*/case 33:a=0;loadscr(scr);break;
				/*Alt-E*/case 18:a=1;loadscr(scr);break;
				/*Alt-S*/case 31:a=2;loadscr(scr);break;
				/*Alt-W*/case 17:a=3;loadscr(scr);break;
				/*Alt-O*/case 24:a=4;loadscr(scr);break;
				case 75://left
					if(a==0)a=4;
					else a--;
					b=1;
					loadscr(scr);
				break;
				case 77://right
					if(a==4)a=0;
					else a++;
					b=1;
					loadscr(scr);
				break;
				case 72://up
					if(b==1)b=n;
					else
					{
						if(!strcmp(menustr[a][b-1],"-"))b--;
						b--;
					}
				break;
				case 80://down
					if(b==n)b=1;
					else
					{
						if(!strcmp(menustr[a][b+1],"-"))b++;
						b++;
					}
				break;
			}
		}
		else
		{
			for(i=0;i<n&&menuhot[i]!=upper(ch);i++);
			if(menuhot[i]==upper(ch))
			{
				loadscr(scr);
				*x1=a+1;
				*x2=i+1;
				return;
			}
		}
		n=showmenu(a,b);
		ch=getkey();
	}
	loadscr(scr);
	if(ch==27)
	{
		*x1=0;
		*x2=0;
	}
	else
	{
		*x1=a+1;
		*x2=b;
	}
}
void menu(int c)
{
	int a,b;
	hidecursor();
	getchoice(&a,&b,c);
	showcursor();
	if(a==0&&b==0)return;
	switch(a)
	{
		case 1:
			switch(b)
			{
				case 1:newfile();break;
				case 2:openfile();break;
				case 3:savefile();break;
				case 4:saveas();break;
				case 5:saveall();break;
				case 7:printfile();break;
				case 8:system("c:\\command");break;
				case 10:quit=1;break;
			}
		break;
		case 2:
			switch(b)
			{
				case 1:copyblock();clearblock();break;
				case 2:copyblock();break;
				case 3:pasteblock();break;
				case 4:clearblock();break;
			}
		break;
		case 3:
			switch(b)
			{
				case 1:find1st();break;
				case 2:replace();break;
				case 3:find2nd();break;
			}
		break;
		case 4:
			switch(b)
			{
				case 1:resize();break;
				case 2:zoom();break;
				case 3:nextwindow();break;
				case 4:closewindow();break;
				case 5:closeall();break;
			}
		break;
		case 5:
			switch(b)
			{
				case 1:farmode=!farmode;break;
				case 2:showtime=!showtime;break;
				case 4:intro();break;
			}
	}
}
//------------------------
void move(int direction)
{
	switch(direction)
	{
		case 1:up();break;
		case 2:down();break;
		case 3:left();break;
		case 4:right();break;
		case 5:pageup();break;
		case 6:pagedown();break;
		case 7:home();break;
		case 8:end();break;
	}
}
//----------
void reverseblock()
{
	int xx,yy;
	xx=bx1;yy=by1;
	bx1=bx2;by1=by2;
	bx2=xx;by2=yy;
}
//-----------
void block(int direction)
{
	if((bx1==mx)&&(by1==my))
	{
		move(direction);
		bx1=mx;
		by1=my;
	}
	else
		if((bx2==mx)&&(by2==my))
		{
			move(direction);
			bx2=mx;
			by2=my;
		}
		else
		{
			bx1=mx;
			by1=my;
			move(direction);
			bx2=mx;
			by2=my;
		}
	if((by1>by2)||((by1==by2)&&(bx1>bx2)))
		reverseblock();
}
//----------------
void copyblock()
{
	struct lines_st*q,*r;
	int i;
	freelist(bstart);
	for(h=start,i=0;i<by1;i++,h=h->next);
	if(by1==by2)
	{
		if(bx1==bx2)
			bstart=NULL;
		else
		{
			q=(struct lines_st*)malloc(sizeof(struct lines_st));
			for(i=0;i<(bx2-bx1)&&(i+bx1<strlen(h->s));i++)
				q->s[i]=h->s[i+bx1];
			for(;i<(bx2-bx1);i++)
				q->s[i]=' ';
			q->s[i]=0;
			q->next=NULL;
			q->prev=NULL;
			bstart=q;
		}
	}
	else
	{
		q=(struct lines_st*)malloc(sizeof(struct lines_st));
		q->s[0]=0;
		for(i=0;i+bx1<strlen(h->s);i++)
			q->s[i]=h->s[i+bx1];
		q->s[i]=0;
		q->prev=NULL;
		bstart=q;
		h=h->next;
		for(i=by1+1;i<by2;i++)
		{
			r=(struct lines_st*)malloc(sizeof(struct lines_st));
			strcpy(r->s,h->s);
			q->next=r;
			r->prev=q;
			q=r;
			h=h->next;
		}
		r=(struct lines_st*)malloc(sizeof(struct lines_st));
		for(i=0;h->s[i]&&i<bx2;i++)
			r->s[i]=h->s[i];
		r->s[i]=0;
		q->next=r;
		r->prev=q;
		r->next=NULL;
	}
}
//----------------
void clearblock()
{
	int x;
	if(by1==by2&&bx1==bx2)return;
	struct lines_st*q,*r;
	int i;
	for(q=start,i=0;i<by1;i++,q=q->next);
	if(by1!=by2)
	{
		for(r=start,i=0;i<by2;i++,r=r->next);
		for(i=0;(i+bx2)<strlen(r->s);i++)
			q->s[i+bx1]=r->s[i+bx2];
		q->s[i+bx1]=0;
		mx=0;
		my=by1;
		while(y0>my)
		{
			ps=ps->prev;
			y0--;
		}
		while(y0+20<my)
		{
			ps=ps->next;
			y0++;
		}
		p=q->next;
		for(i=by1;i<by2;i++)
		{
			p->s[0]=0;
			del();
		}
		p=q;
		mx=bx1;
	}
	else
	{
		for(i=0;i+bx2<strlen(q->s);i++)
			q->s[i+bx1]=q->s[i+bx2];
		q->s[i+bx1]=0;
		my=by1;
		p=q;
		while(y0>my)
		{
			ps=ps->prev;
			y0--;
		}
		while(y0+20<my)
		{
			ps=ps->next;
			y0++;
		}
	}
	bx1=mx;
	bx2=mx;
	by1=my;
	by2=my;
}
//---------------
void pasteblock()
{
	int i,x,y,ins1;
	if(!bstart)return;
	struct lines_st *q,*r;
	q=bstart;
	r=p;
	ins1=ins;
	ins=1;
	x=mx;
	y=my;
	if(mx>strlen(p->s))
	{
		for(i=strlen(p->s);i<mx;i++)
			p->s[i]=' ';
		p->s[i]=0;
	}
	while(q)
	{
		for(i=0;q->s[i];i++)
			add(p->s,mx++,q->s[i]);
		if(q->next)
			enter();
		q=q->next;
	}
	bx2=mx;
	by2=my;
	p=r;
	mx=x;
	my=y;
	ins=ins1;
	bx1=mx;
	by1=my;
}